import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Task3 {

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(br.readLine());
		int n = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());
		st = new StringTokenizer(br.readLine());
		ArrayList<Integer> a = new ArrayList<Integer>();
		for (int i = 0; i < m; i++) {
			a.add(Integer.parseInt(st.nextToken()));
		}
		st = new StringTokenizer(br.readLine());
		ArrayList<Integer> b = new ArrayList<Integer>();
		for (int i = 0; i < n; i++) {
			b.add(Integer.parseInt(st.nextToken()));
		}
		br.close();

		ArrayList<Integer> actions = new ArrayList<Integer>();

		// a.indexOf
		for (int j = 0; j < m - 1; j++) {
			boolean topok = false;
			do {
				if (a.get(j) == b.get(0))
					topok = true;
				int cur = b.get(0);
				int nextUse = -1;
				ArrayList<Integer> willUseBefore = new ArrayList<Integer>();
				for (int i = j; i < m; i++) {
					if (a.get(i) == cur) {
						if (i == j)
							continue;
						nextUse = i;
						break;
					} else {
						willUseBefore.add(a.get(i));
					}
				}
				if (nextUse == -1) {
					b = insert(b, n - 1, cur);
					actions.add(n - 1 + 1);
					b.remove(0);
					continue;
				}
				int upmost = b.indexOf(a.get(j + 1));
				for (Integer i : willUseBefore) {
					upmost = Math.max(upmost, b.indexOf(i));
				}
				b = insert(b, upmost, cur);
				actions.add(upmost + 1);
				b.remove(0);

			} while (!topok);

		}

		// now last j
		actions.add(1);

		System.out.println(actions.size());
		for (Integer i : actions) {
			System.out.print(i + " ");
		}
		System.out.println();

	}

	public static ArrayList<Integer> insert(ArrayList<Integer> list, int insertAfterIndex, int toInsert) {
		int iai = insertAfterIndex;
		ArrayList<Integer> l1 = new ArrayList<Integer>(list.subList(0, iai + 1));
		l1.add(toInsert);
		l1.addAll(list.subList(iai + 1, list.size()));
		return l1;
	}

}
