import java.util.Scanner;

public class Task6q1m {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int k = sc.nextInt();
		sc.close();

		// ans = ways[n-k][k]
		long[][] u = new long[n + 1][n + 1];
		u[0][0] = 0;
		for (int i = 1; i <= n; i++) {
			u[0][i] = 0;
		}

		long[][] d = new long[n + 1][n + 1];
		d[0][0] = 0;
		for (int i = 1; i <= n; i++) {
			d[0][i] = 1;
		}

		for (int i = 1; i <= n; i++) {
			for (int j = 0; j <= n; j++) {

				for (int l = j + 1; (l <= i) && (i - l >= 0); l++) {
					u[i][j] += d[i - l][l];
					u[i][j] %= (1_000_000_000 + 7);
				}

				for (int l = 1; (l < j) && (i - l >= 0); l++) {
					d[i][j] += u[i - l][l];
					d[i][j] %= (1_000_000_000 + 7);
				}
			}
		}
		// ways[i][j] %= (1_000_000_000 + 7);

		System.out.println("u:");
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				System.out.print(u[i][j] + " ");
			}
			System.out.println();
		}
		System.out.println("-----");

		System.out.println("d:");
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				System.out.print(d[i][j] + " ");
			}
			System.out.println();
		}
		System.out.println("-----");

		System.out.println(u[n - k][k] + d[n - k][k]);
	}

}
