import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class Task2 {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		long k = sc.nextLong();
		sc.close();

		long res = func(k);
		if (res == -1)
			System.out.println("none");
		else
			System.out.println(res);
	}

	public static long func(long k) {
		if (k == 0) {
			System.out.println(0);
			return -1;
		}

		ArrayList<Long> possible = new ArrayList<Long>();

		long sqrt = (long) Math.sqrt(Math.abs(k));
		for (long i = sqrt; i >= -sqrt; i--) {
			if (i == 0)
				continue;
			if (k % i != 0)
				continue;
			long a = i;
			long b = k / i;
			if ((b + a) % 2 != 0)
				continue;
			long m = (b + a) / 2;
			if (m < 0)
				continue;

			possible.add(m);
		}

		if (possible.size() == 0)
			return -1;

		Collections.sort(possible);
		return possible.get(0);
	}

}
